//----------------------------------------------------------------------//
// NyanFi																//
//  񌟍(eLXgrA[)										//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <RegularExpressions.hpp>
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "TxtViewer.h"
#include "MainFrm.h"
#include "GenInfDlg.h"
#include "FindTxtDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFindTextDlg *FindTextDlg;

//---------------------------------------------------------------------------
__fastcall TFindTextDlg::TFindTextDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFindTextDlg::FormCreate(TObject *Sender)
{
	set_ComboBox_AutoComp(this);

	FindComboBox->Tag = CBTAG_HISTORY;

	set_ComboBoxText(CodePageComboBox,
		_T("Shift_JIS\r\n")
		_T("ISO-8859-1\r\n")
		_T("UTF-16\r\n")
		_T("UTF-16BE\r\n")
		_T("US-ASCII\r\n")
		_T("EUC-JP\r\n")
		_T("UTF-7\r\n")
		_T("UTF-8\r\n"));
}

//---------------------------------------------------------------------------
void __fastcall TFindTextDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	IniFile->LoadComboBoxItems(FindComboBox, _T("FindTxtHistory"));
	if (fromTV) {
		FindComboBox->Text = TxtViewer->get_SelText();
		if (FindComboBox->Text.IsEmpty()) FindComboBox->Text = TxtViewer->FindWord;
	}
	else
		FindComboBox->Text = GeneralInfoDlg->FindWord;

	UpDownGroup->ItemIndex		= IniFile->ReadIntGen(_T("FindTxtDlgUpDown"),	1);
	CaseCheckBox->Checked		= IniFile->ReadBoolGen(_T("FindTxtDlgCase"));
	RegExCheckBox->Checked		= IniFile->ReadBoolGen(_T("FindTxtDlgRegEx"));

	set_MigemoCheckBox(MigemoCheckBox, _T("FindTxtDlgMigemo"));

	BytesCheckBox->Checked		= IniFile->ReadBoolGen(_T("FindTxtDlgBytes"));
	HighlightCheckBox->Checked	= IniFile->ReadBoolGen(_T("FindTxtDlgHighlight"));
	HighlightCheckBox->Visible	= fromTV;
	CloseCheckBox->Checked		= IniFile->ReadBoolGen(_T("FindTxtDlgClose"));
	CodePageComboBox->ItemIndex = IniFile->ReadIntGen(_T("FindTxtDlgCodePage"));
	FindOptChangedClick(NULL);

	if (fromTV) TxtViewer->Repaint(true);
}
//---------------------------------------------------------------------------
void __fastcall TFindTextDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	if (fromTV) TxtViewer->Highlight = HighlightCheckBox->Checked;

	IniFile->SavePosInfo(this);

	IniFile->SaveComboBoxItems(FindComboBox, _T("FindTxtHistory"));

	IniFile->WriteIntGen(_T("FindTxtDlgUpDown"),		UpDownGroup);
	IniFile->WriteBoolGen(_T("FindTxtDlgCase"),			CaseCheckBox);
	IniFile->WriteBoolGen(_T("FindTxtDlgRegEx"),		RegExCheckBox);
	IniFile->WriteBoolGen(_T("FindTxtDlgMigemo"),		MigemoCheckBox);
	IniFile->WriteBoolGen(_T("FindTxtDlgBytes"),		BytesCheckBox);
	IniFile->WriteBoolGen(_T("FindTxtDlgHighlight"),	HighlightCheckBox);
	IniFile->WriteBoolGen(_T("FindTxtDlgClose"),		CloseCheckBox);
	IniFile->WriteIntGen(_T("FindTxtDlgCodePage"),		CodePageComboBox);

	fromTV = false;
}

//---------------------------------------------------------------------------
//IvV̕ύX
//---------------------------------------------------------------------------
void __fastcall TFindTextDlg::FindOptChangedClick(TObject *Sender)
{
	BytesCheckBox->Visible	   = fromTV && TxtViewer->isBinary;
	CodePageComboBox->Visible  = fromTV && TxtViewer->isBinary;

	bool not_bytes = !BytesCheckBox->Visible || !BytesCheckBox->Checked;
	set_FormTitle(this, not_bytes? _T("񌟍") : _T("oCg񌟍"));
	HighlightCheckBox->Enabled = not_bytes;
	if (fromTV) TxtViewer->Highlight = not_bytes;
	CodePageComboBox->Enabled  = !not_bytes;

	if (MigemoCheckBox->Enabled && MigemoCheckBox->Checked) {
		RegExCheckBox->Checked = false;
		RegExCheckBox->Enabled = false;
	}
	else
		RegExCheckBox->Enabled = not_bytes;

	FindComboBox->SetFocus();
	FindComboBoxChange(FindComboBox);
}
//---------------------------------------------------------------------------
void __fastcall TFindTextDlg::SubOptClick(TObject *Sender)
{
	FindComboBox->SetFocus();
}

//---------------------------------------------------------------------------
//񗓂ł̃L[
//---------------------------------------------------------------------------
void __fastcall TFindTextDlg::FindComboBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	switch (idx_of_word_i(_T("Ctrl+N|Ctrl+D|Ctrl+P|Ctrl+U|Ctrl+M|Ctrl+R|Ctrl+B"), get_KeyStr(Key, Shift))) {
	case 0: case 1:
		UpDownGroup->ItemIndex = 1;  Repaint();  FindNextAction->Execute();
		break;
	case 2: case 3:
		UpDownGroup->ItemIndex = 0;  Repaint();  FindNextAction->Execute();
		break;
	case 4:
		if (MigemoCheckBox->Enabled) MigemoCheckBox->Checked = !MigemoCheckBox->Checked;
		break;
	case 5:
		RegExCheckBox->Checked = !RegExCheckBox->Checked;
		break;
	case 6:
		if (BytesCheckBox->Visible) BytesCheckBox->Checked = !BytesCheckBox->Checked;
		break;
	default:
		return;
	}

	Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TFindTextDlg::FindComboBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	if (is_KeyDown(VK_CONTROL) && Key!=0x03 && Key!=0x16 && Key!=0x18) Key = 0;
}

//---------------------------------------------------------------------------
//񂪕ωrA[̕\XV
//---------------------------------------------------------------------------
void __fastcall TFindTextDlg::FindComboBoxChange(TObject *Sender)
{
	if (fromTV) {
		TxtViewer->isCase	   = CaseCheckBox->Checked;
		TxtViewer->isRegEx	   = RegExCheckBox->Checked;
		TxtViewer->isMigemo    = MigemoCheckBox->Enabled && MigemoCheckBox->Checked;
		TxtViewer->isBytes	   = BytesCheckBox->Visible && BytesCheckBox->Checked;
		TxtViewer->FindWord    = FindComboBox->Text;
		TxtViewer->BinCodePage = get_CodePageOfName(CodePageComboBox->Text);

		UnicodeString ptn;
		if (!TxtViewer->FindWord.IsEmpty()) {
			//oCg
			if (TxtViewer->isBytes) {
				ptn = TxtViewer->FindWord;
				if (!USTARTS_TS('\"', ptn) && !USTARTS_TS('\'', ptn)) {
					//l`FbN
					TStringDynArray b_lst = SplitString(Trim(ptn), " ");
					try {
						for (int i=0; i<b_lst.Length; i++) {
							UnicodeString s = b_lst[i];
							s = REPLACE_TS(s, "?", "0");
							if (s.Length()==2)		("0x" + s).ToInt();
							else if (s.Length()==8)	s.ToInt();
							else Abort();
						}
					}
					catch (...) {
						ptn = EmptyStr;
					}
				}
			}
			//
			else {
				if (TxtViewer->isRegEx && !TxtViewer->isMigemo)
					ptn = TxtViewer->FindWord;
				else
					ptn = usr_Migemo->GetRegExPtn(TxtViewer->isMigemo, TxtViewer->FindWord);

				//K\p^[̃`FbN
				if (!chk_RegExPtn(ptn)) {
					FindComboBox->Color = col_Illegal;
					ptn = EmptyStr;
				}
				else FindComboBox->Color = scl_Window;
			}
		}
		else FindComboBox->Color = scl_Window;

		TxtViewer->RegExPtn = RegExPtn = ptn;
		TxtViewer->Repaint(true);
	}
	else {
		GeneralInfoDlg->FindWord = FindComboBox->Text;
		UnicodeString ptn;
		if (!FindComboBox->Text.IsEmpty()) {
			if (RegExCheckBox->Checked)
				ptn = FindComboBox->Text;
			else
				ptn = usr_Migemo->GetRegExPtn(MigemoCheckBox->Enabled && MigemoCheckBox->Checked, FindComboBox->Text);
			//K\p^[̃`FbN
			if (!chk_RegExPtn(ptn)) {
				FindComboBox->Color = col_Illegal;
				ptn = EmptyStr;
			}
			else FindComboBox->Color = scl_Window;
		}
		else FindComboBox->Color = scl_Window;

		GeneralInfoDlg->RegExPtn = RegExPtn = ptn;
	}
}
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
void __fastcall TFindTextDlg::FindNextActionExecute(TObject *Sender)
{
	if (fromTV) {
		if (!NyanFiForm->TxtScrollPanel->Visible) return;

		TxtViewer->ExeCommand((UpDownGroup->ItemIndex==1)? _T("FindDown") : _T("FindUp"));
		if (TxtViewer->LastFound && !TxtViewer->isMigemo)
			add_ComboBox_history(FindComboBox, TxtViewer->FindWord);
	}
	else {
		if (GeneralInfoDlg->FindText(UpDownGroup->ItemIndex==1)) {
			if (!MigemoCheckBox->Enabled || !MigemoCheckBox->Checked)
				add_ComboBox_history(FindComboBox, FindComboBox->Text);
		}
	}

	if (CloseCheckBox->Checked) Close();
}
//---------------------------------------------------------------------------
void __fastcall TFindTextDlg::FindNextActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !RegExPtn.IsEmpty();

	FindComboBox->Tag
		= CBTAG_HISTORY | (FindComboBox->Focused()? CBTAG_RGEX_V : 0) | (RegExCheckBox->Checked? CBTAG_RGEX_E : 0);
}

//---------------------------------------------------------------------------
void __fastcall TFindTextDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift);
}
//---------------------------------------------------------------------------
