//----------------------------------------------------------------------//
// NyanFi																//
//  ֐^[U`^}[Nsꗗ								//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <Vcl.Clipbrd.hpp>
#include <RegularExpressions.hpp>
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "TxtViewer.h"
#include "FuncDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFuncListDlg *FuncListDlg;

//---------------------------------------------------------------------------
__fastcall TFuncListDlg::TFuncListDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FormCreate(TObject *Sender)
{
	ListScrPanel = new UsrScrollPanel(ListPanel, FuncListBox, USCRPNL_FLAG_P_WP | USCRPNL_FLAG_L_WP);

	set_ComboBox_AutoComp(this);

	UserDefComboBox->Tag = CBTAG_HISTORY;
	FuncListBox->Tag	 = LBTAG_OPT_ZOOM | LBTAG_OPT_LNNO | LBTAG_OPT_LCPY;

	FunctionList = new TStringList();
	UserDefList  = new TStringList();
	MarkLineList = new TStringList();

	ListMode = 0;
	ToFilter = false;
}
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	set_MigemoCheckBox(MigemoCheckBox, _T("FuncListMigemo"));

	IniFile->LoadComboBoxItems(UserDefComboBox, _T("UserDefHistory"));
	NameOnlyCheckBox->Checked = IniFile->ReadBoolGen(_T("FuncListNameOnly"));
	LinkCheckBox->Checked	  = IniFile->ReadBoolGen(_T("FuncListLinkLine"));
	RegExCheckBox->Checked	  = IniFile->ReadBoolGen(_T("FuncListRegEx"));
	HdLnCheckBox->Checked	  = IniFile->ReadBoolGen(_T("FuncListHeadline"));

	if (!UserDefStr.IsEmpty()) {
		UserDefComboBox->Text = UserDefStr;
		UserDefStr = EmptyStr;
	}
	else UserDefComboBox->Text = IniFile->ReadStrGen(_T("FuncListUserStr"));

	TListBox *lp = FuncListBox;
	lp->Clear();
	ListPanel->Color = lp->Color;
	set_StdListBox(lp);
	set_UsrScrPanel(ListScrPanel);

	if (!UnInitializing) InitializeList();

	(ToFilter? (TWinControl*)FilterEdit : (TWinControl*)lp)->SetFocus();
	InvColIfNotFocused(FilterEdit);
	FilterEdit->Text = EmptyStr;

	ReqEdit = false;
}
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	IniFile->SavePosInfo(this);

	IniFile->WriteBoolGen(_T("FuncListMigemo"),		MigemoCheckBox);
	IniFile->WriteBoolGen(_T("FuncListNameOnly"),	NameOnlyCheckBox);
	IniFile->WriteBoolGen(_T("FuncListLinkLine"),	LinkCheckBox);
	IniFile->WriteStrGen(_T("FuncListUserStr"),		UserDefComboBox->Text);
	IniFile->WriteBoolGen(_T("FuncListRegEx"),		RegExCheckBox);
	IniFile->WriteBoolGen(_T("FuncListHeadline"),	HdLnCheckBox);

	IniFile->SaveComboBoxItems(UserDefComboBox, _T("UserDefHistory"));
}
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FormDestroy(TObject *Sender)
{
	delete FunctionList;
	delete UserDefList;
	delete MarkLineList;
	delete ListScrPanel;
}

//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::ClearList()
{
	FunctionList->Clear();
	UserDefList->Clear();
	MarkLineList->Clear();
	FuncListBox->Clear();
}

//---------------------------------------------------------------------------
//ꗗ̏
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::InitializeList(int mode)
{
	if (mode==ListMode) return;
	if (mode!=-1) ListMode = mode;

	cursor_HourGlass();

	EmpPtn = EmptyStr;
	UnicodeString cap_str, tmpstr;

	//[U`ꗗ
	if (ListMode==1) {
		cap_str.USET_T("[U`ꗗ");
		UserDefPanel->Visible	  = true;
		NameOnlyCheckBox->Visible = false;
		if (UserDefComboBox->Text.IsEmpty()) {
			UserDefList->Clear();
			UpdateList();
		}
		else if (UserDefList->Count==0) UpdUserDefAction->Execute();
		else UpdateList();
	}
	//}[Nsꗗ
	else if (ListMode==2) {
		cap_str.USET_T("}[Nsꗗ");
		UserDefPanel->Visible	  = false;
		NameOnlyCheckBox->Visible = false;

		//ꗗ쐬
		MarkLineList->Clear();
		TStringDynArray m_lst = split_strings_semicolon(TxtViewer->MarkListStr);
		for (int i=0; i<m_lst.Length; i++) {
			int lno = m_lst[i].ToIntDef(0);  if (lno==0) continue;
			for (int j=0; j<TxtViewer->MaxDispLine; j++) {
				line_rec *lp = TxtViewer->get_LineRec(j);
				if (lp->LineIdx==0 && lno==lp->LineNo) {
					MarkLineList->AddObject(TxtViewer->DispLines->Strings[j], (TObject*)lno);
					break;
				}
			}
		}
		UpdateList();
	}
	//֐ꗗ
	else {
		cap_str.USET_T("֐ꗗ");
		UserDefPanel->Visible	  = false;
		NameOnlyCheckBox->Visible = true;

		UnicodeString mat_ptn;
		UnicodeString fext = get_extension(TxtViewer->FileName);
		if (test_FileExt(fext, _T(".pas.dpr.dpk.inc")))
			mat_ptn.USET_T("^(procedure|function)[\\t ]+[_a-zA-Z]\\w*");
		else if (test_FileExt(fext, _T(".php")) && !TxtViewer->isHtm2Txt)
			mat_ptn.USET_T("^(function)[\\t ]+[_a-zA-Z]\\w*");
		else if (test_FileExt(fext, _T(".js.jsx.as"))) {
			mat_ptn.USET_T("^(function)[\\t ]+[_a-zA-Z]\\w*\\(");
			EmpPtn.USET_T("\\b[_a-zA-Z]\\w*\\(");
		}
		else if (test_FileExt(fext, _T(".vbs.vb")))
			mat_ptn.USET_T("^[\\t ]*((public|private)[\\t ])?(shared[\\t ])?(sub|proc|function)[\\t ]+[_a-zA-Z]\\w*");
		else if (test_FileExt(fext, _T(".pl")))
			mat_ptn.USET_T("^sub[\\t ]+[_a-zA-Z]\\w*");
		else if (test_FileExt(fext, _T(".rb.py")))
			mat_ptn.USET_T("^[\\t ]*def[\\t ]+[_a-zA-Z]\\w*");
		else if (test_FileExt(fext, _T(".mac")))
			mat_ptn.USET_T("^(sub|proc|function)[\\t ]+[_a-zA-Z]\\w*");
		else if (test_FileExt(fext, _T(".java"))) {
			mat_ptn.USET_T("^[\\t ]*((public|private|protected)[\\t ]+)?[_a-zA-Z][^\\(=;:]*[\\t ]+[_a-zA-Z]\\w*\\([^;]*$");
			EmpPtn.USET_T("\\b[_a-zA-Z]\\w*\\(");
		}
		else if (test_FileExt(fext, _T(".scala"))) {
			mat_ptn.USET_T("^[\\t ]*def[\\t ]+[_a-zA-Z][^:]*:[^:]*");
			EmpPtn.USET_T("\\b[_a-zA-Z]\\w*[\\(\\[:]");
		}
		else if (test_FileExt(fext, _T(".lua"))) {
			mat_ptn.USET_T("^(local[\\t ])?function[\\t ]+[_a-zA-Z][\\w\\.:]*\\(");
			EmpPtn.USET_T("\\b[_a-zA-Z]\\w*\\(");
		}
		else if (test_FileExt(fext, _T(".sh"))) {
			mat_ptn.USET_T("^(function[\\t ])?[_a-zA-Z]\\w*\\(");
			EmpPtn.USET_T("\\b[_a-zA-Z]\\w*\\(");
		}
		else if (test_FileExt(fext, _T(".swift"))) {
			mat_ptn.USET_T("^[\\t ]*func[\\t ]+[_a-zA-Z]\\w*\\(");
			EmpPtn.USET_T("\\b[_a-zA-Z]\\w*\\(");
		}
		else if (test_FileExt(fext, _T(".rs")))
			mat_ptn.USET_T("^(pub[\\t ])?(fn)[\\t ]+[_a-zA-Z]\\w*");
		else if (test_FileExt(fext, _T(".bat.cmd.qbt"))) {
			cap_str.USET_T("xꗗ");
			mat_ptn.USET_T("^:[^:]+");
		}
		else if (TxtViewer->isIniFmt) {
			cap_str.USET_T("ZNVꗗ");
			mat_ptn.USET_T("^\\[.+\\]");
		}
		else if (test_HtmlExt(fext) || TxtViewer->isAozora || TxtViewer->isAwstats) {
			cap_str.USET_T("oꗗ");
			mat_ptn = TxtViewer->HeadlinePtn;
		}
		else if (test_FileExt(fext, _T(".eml"))) {
			cap_str.USET_T("ꗗ");
			mat_ptn = TxtViewer->HeadlinePtn;
		}
		else if (TxtViewer->isLog) {
			cap_str.USET_T("^XNꗗ");
			mat_ptn = TxtViewer->HeadlinePtn;
		}
		else if (test_FileExt(fext, _T(".tox"))) {
			cap_str.USET_T("^Cgꗗ");
			mat_ptn.USET_T("^#T");
		}
		else {	//c
			mat_ptn.USET_T("^([_a-zA-Z][^\\(=;:,]*[\\t ]+)*\\**([_a-zA-Z]\\w*::)?[~_a-zA-Z]\\w*\\([^;]*$");
			EmpPtn.USET_T("(\\b|~)[_a-zA-Z]\\w*\\(");
		}

		if (!chk_RegExPtn(EmpPtn)) EmpPtn = EmptyStr;

		Opt1Panel->Visible = (ListMode==0 && !EmpPtn.IsEmpty());	//O

		//ꗗ쐬
		if (FunctionList->Count==0) {
			bool has_par = (ListMode==0 && contains_s(mat_ptn, _T("\\(")));
			bool non_tab = USTARTS_TS('^', mat_ptn) && !USTARTS_TS("^[\\t ]*", mat_ptn);
			TRegExOptions opt; opt << roIgnoreCase;
			for (int i=0; i<TxtViewer->MaxDispLine; i++) {
				line_rec *rp = TxtViewer->get_LineRec(i);  if (rp->LineIdx>0) continue;
				UnicodeString lbuf = TrimRight(TxtViewer->get_DispLine(i));
				if (non_tab && (USTARTS_TS('\t', lbuf) || USTARTS_TS(' ', lbuf))) continue;
				if (has_par && (!contains_s(lbuf, _T('(')) || contains_s(lbuf, _T('=')))) continue;
				if (TRegEx::IsMatch(lbuf, mat_ptn, opt)) {
					if (TxtViewer->isAozora) lbuf = replace_regex(lbuf, _T("mu.*?v((|)o)n"), null_TCHAR);
					FunctionList->AddObject(lbuf, (TObject*)rp->LineNo);
				}
			}
		}
		UpdateList();
	}

	Caption = cap_str;

	cursor_Default();
}

//---------------------------------------------------------------------------
//ꗗ̕\XV
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::UpdateList(
	bool link)	//rA[sڂɘA (default = false)
{
	std::unique_ptr<TStringList> flst(new TStringList());
	flst->Assign((ListMode==0)? FunctionList : ((ListMode==1)? UserDefList : MarkLineList));

	//tB^
	UnicodeString ptn = usr_Migemo->GetRegExPtn(MigemoCheckBox->Checked, FilterEdit->Text);
	if (!ptn.IsEmpty()) {
		TRegExOptions opt; opt << roIgnoreCase;
		int i=0;
		while (i<flst->Count) {
			UnicodeString lbuf = flst->Strings[i];
			if (NameOnlyCheckBox->Checked && ListMode==0 && !EmpPtn.IsEmpty()) {
				TRegExOptions opt; opt << roIgnoreCase;
				TMatch mt = TRegEx::Match(lbuf, EmpPtn, opt);
				if (mt.Success) {
					lbuf = mt.Value;
					remove_end_s(lbuf, '(');
				}
			}
			if (!TRegEx::IsMatch(lbuf, ptn, opt)) flst->Delete(i); else i++;
		}
	}

	TListBox *lp = FuncListBox;
	set_RedrawOff(lp);
	{
		lp->Items->Assign(flst.get());
		if (lp->Count>0) {
			int idx = 0;
			if (LineNo!=-1) {
				for (int i=0; i<lp->Count; i++) {
					int lno = (int)lp->Items->Objects[i];
					if (LineNo < lno) break;
					if (LineNo >= lno) idx = i;
				}
			}
			lp->ItemIndex = idx;
		}
	}
	set_RedrawOn(lp);
	ListScrPanel->UpdateKnob();

	if (link) ToLine();
}

//---------------------------------------------------------------------------
//Xgڂ̍sֈړ
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::ToLine()
{
	TListBox *lp = FuncListBox;
	int idx = lp->ItemIndex;
	if (idx>=0 && idx<lp->Count) {
		LineNo = (int)lp->Items->Objects[idx];
		TxtViewer->ToLine(LineNo);
	}
}

//---------------------------------------------------------------------------
//ڂ̕`
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FuncListBoxDrawItem(TWinControl *Control, int Index,
		TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas *cv = lp->Canvas;
	cv->Font->Assign(lp->Font);
	cv->Brush->Color = col_bgList;
	TRect rc = Rect;
	cv->FillRect(rc);

	UnicodeString lbuf = lp->Items->Strings[Index];
	int lno = (int)lp->Items->Objects[Index];

	int xp = Rect.Left;
	int yp = Rect.Top + get_TopMargin2(cv);

	//}[N
	if (ListMode!=2) {
		rc.Right = rc.Left + 8;
		cv->Brush->Color = col_bgLineNo;  cv->FillRect(rc);
		if (TxtViewer->IsMarked(lno)) {
			InflateRect(rc, -1, -4);
			cv->Brush->Color = col_Mark;  cv->FillRect(rc);
		}
		xp += 8;
	}

	//sԍ
	rc = Rect;  rc.Left = xp;
	cv->Font->Assign(lp->Font);
	LineNoOut(cv, rc, lno);
	xp = rc.Left + 4;

	//e
	cv->Brush->Color = col_bgList;
	cv->Font->Color = col_fgList;
	if (ListMode==0) {
		if (TxtViewer->isIniFmt) {
			cv->Font->Color = col_Headline;
			cv->TextOut(xp, yp, lbuf);
		}
		else if (!EmpPtn.IsEmpty()) {
			//֐
			std::unique_ptr<TStringList> elist(new TStringList());
			TRegExOptions opt; opt << roIgnoreCase;
			TMatch mt = TRegEx::Match(lbuf, EmpPtn, opt);
			if (mt.Success) {
				UnicodeString wd = mt.Value;
				if (ends_tchs(_T("([:"), wd)) delete_end(wd);
				elist->Add(wd);
				if (NameOnlyCheckBox->Checked) lbuf = wd;
			}
			EmphasisTextOut(lbuf, elist.get(), cv, xp, yp, false, true, col_Headline, cv->Brush->Color);
		}
		else cv->TextOut(xp, yp, lbuf);
	}
	else cv->TextOut(xp, yp, lbuf);

	//J[\
	draw_ListCursor(lp, Rect, Index, State);
}

//---------------------------------------------------------------------------
//L[
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FuncListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	TListBox *lp = FuncListBox;
	int idx = lp->ItemIndex;

	UnicodeString KeyStr = get_KeyStr(Key, Shift);
	UnicodeString cmd_F  = Key_to_CmdF(KeyStr);
	UnicodeString cmd_V  = Key_to_CmdV(KeyStr);

	try {
		if		(equal_ENTER(KeyStr))				CloseListAction->Execute();
		else if	(equal_ESC(KeyStr) || USAME_TI(cmd_F, "ReturnList"))			ModalResult = mrCancel;
		else if (USAME_TI(cmd_F, "FileEdit") || USAME_TI(cmd_V, "FileEdit"))	ReqEditAction->Execute();
		else if (USAME_TI(cmd_V, "FunctionList"))	InitializeList(0);	//֐ꗗ
		else if (USAME_TI(cmd_V, "UserDefList"))	InitializeList(1);	//[U`ꗗ
		else if (USAME_TI(cmd_V, "MarkList"))		InitializeList(2);	//}[Nsꗗ
		//}[N
		else if (USAME_TI(cmd_V, "Mark")) {
			if (ListMode!=2 && idx>=0 && idx<lp->Count) {
				TxtViewer->MarkLine((int)lp->Items->Objects[idx]);
				lp->Repaint();
			}
		}
		//̑̈ړȂ
		else if (USAME_TI(cmd_F, "IncSearch"))		FilterEdit->SetFocus();
		else if (ExeCmdListBox(lp, cmd_F) || ExeCmdListBox(lp, cmd_V))	;
		else if (contained_wd_i(_T("S|Ctrl+S"), KeyStr) && ListMode==1)	UserDefComboBox->SetFocus();
		else if (contained_wd_i(KeyStr_Filter, KeyStr)) FilterEdit->SetFocus();
		else if (contained_wd_i(KeysStr_Popup, KeyStr)) show_PopupMenu(lp->PopupMenu, lp);

		//A
		if (LinkCheckBox->Checked && idx!=-1 && idx!=lp->ItemIndex) ToLine();
	}
	catch (EAbort &e) {
		beep_Warn();
	}

	if (!is_DialogKey(Key)) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FuncListBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	//CN^T[`
	if (_istalnum(Key) || Key==VK_SPACE) Key = 0;
}

//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FuncListBoxDblClick(TObject *Sender)
{
	CloseListAction->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FuncListBoxClick(TObject *Sender)
{
	if (LinkCheckBox->Checked) ToLine();
}

//---------------------------------------------------------------------------
//tB^ɂꗗ̍XV
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FilterEditChange(TObject *Sender)
{
	UpdateList(LinkCheckBox->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FilterEditEnter(TObject *Sender)
{
	FilterEdit->Color = scl_Window;
}
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FilterEditExit(TObject *Sender)
{
	CloseIME(Handle);
	InvColIfEmpty(FilterEdit);
}

//---------------------------------------------------------------------------
//tB^ł̃L[
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FilterEditKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	UnicodeString KeyStr = get_KeyStr(Key, Shift);
	if (KeyStr.IsEmpty()) return;

	TListBox *lp = FuncListBox;
	int idx = lp->ItemIndex;

	if		(contained_wd_i(KeysStr_ToList, KeyStr))	lp->SetFocus();
	else if (MovListBoxFromFilter(lp, KeyStr))		;
	else if (SameText(KeyStr, KeyStr_Migemo))		MigemoCheckBox->Checked = !MigemoCheckBox->Checked;
	else if (equal_ENTER(KeyStr))					CloseListAction->Execute();
	else if	(equal_ESC(KeyStr))						ModalResult = mrCancel;
	else return;

	lp->Repaint();
	if (LinkCheckBox->Checked && idx!=lp->ItemIndex) ToLine();

	Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FilterEditKeyPress(TObject *Sender, System::WideChar &Key)
{
	if ((is_KeyDown(VK_CONTROL) && Key!=0x03 && Key!=0x16) || Key==VK_RETURN || Key==VK_ESCAPE) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::MigemoCheckBoxClick(TObject *Sender)
{
	UpdateList(LinkCheckBox->Checked);
}

//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::NameOnlyCheckBoxClick(TObject *Sender)
{
	FuncListBox->Repaint();
}

//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::UserDefComboBoxClick(TObject *Sender)
{
	UpdUserDefAction->Execute();
}

//---------------------------------------------------------------------------
//[U`ꗗ̍XV
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::UpdUserDefActionExecute(TObject *Sender)
{
	cursor_HourGlass();
	UserDefList->Clear();
	UnicodeString mat_ptn = UserDefComboBox->Text;
	if (!RegExCheckBox->Checked) mat_ptn = TRegEx::Escape(mat_ptn);
	if (!mat_ptn.IsEmpty()) {
		TRegExOptions opt; opt << roIgnoreCase;
		TStringList *lst = (test_HtmlExt(get_extension(TxtViewer->FileName)) && TxtViewer->isHtm2Txt)?
								 TxtViewer->TxtBufList2 : TxtViewer->TxtBufList;
		for (int i=0; i<lst->Count; i++) {
			UnicodeString lbuf = lst->Strings[i];
			if (TRegEx::IsMatch(lbuf, mat_ptn, opt)) UserDefList->AddObject(lbuf, (TObject*)(i + 1));
		}
		if (UserDefList->Count>0) add_ComboBox_history(UserDefComboBox, UserDefComboBox->Text);
	}
	UpdateList(LinkCheckBox->Checked);
	FuncListBox->SetFocus();
	cursor_Default();
}
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::UpdUserDefActionUpdate(TObject *Sender)
{
	TAction *ap = (TAction*)Sender;

	if (ListMode==1) {
		//K\p^[̃`FbN
		UnicodeString uwd = UserDefComboBox->Text;
		bool reg_ng = RegExCheckBox->Checked && !uwd.IsEmpty() && !chk_RegExPtn(uwd);
		UserDefComboBox->Color = reg_ng? col_Illegal : scl_Window;
		ap->Enabled = RegExCheckBox->Checked? (!uwd.IsEmpty() && !reg_ng) : !uwd.IsEmpty();
	}
	else ap->Enabled = false;

	UserDefComboBox->Tag
		= CBTAG_HISTORY | (UserDefComboBox->Focused()? CBTAG_RGEX_V : 0) | (RegExCheckBox->Checked? CBTAG_RGEX_E : 0);
	HdLnCheckBox->Enabled = !test_HtmlExt(get_extension(TxtViewer->FileName));
}

//---------------------------------------------------------------------------
//ꗗ
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::CloseListActionExecute(TObject *Sender)
{
	TListBox *lp = FuncListBox;
	int idx = lp->ItemIndex;
	if (idx>=0 && idx<lp->Count) {
		//oƂĒǉ
		UnicodeString fext = get_extension(TxtViewer->FileName);
		if (ListMode==1 && HdLnCheckBox->Checked && !fext.IsEmpty() && !test_HtmlExt(fext)) {
			UnicodeString mat_ptn = UserDefComboBox->Text;
			if (!RegExCheckBox->Checked) mat_ptn = TRegEx::Escape(mat_ptn);
			UnicodeString fext = get_tkn_r(fext, '.').LowerCase();
			int ix = HeadlineList->IndexOfName(fext);
			if (ix!=-1) HeadlineList->Delete(ix);
			HeadlineList->Add(UnicodeString().sprintf(_T("%s=%s"), fext, mat_ptn.c_str()));
			TxtViewer->HeadlinePtn = mat_ptn;
		}
		//ړ
		ToLine();
		ModalResult = mrOk;
	}
	else beep_Warn();
}
//---------------------------------------------------------------------------
//eLXgGfB^ŊJ
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::ReqEditActionExecute(TObject *Sender)
{
	CmdRequestList->Add("FileEditV");
	CloseListAction->Execute();
}

//---------------------------------------------------------------------------
//ꗗ̓e擾
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::GetStrList(TStringList *lst)
{
	for (int i=0; i<FuncListBox->Count; i++) {
		UnicodeString lbuf = Trim(FuncListBox->Items->Strings[i]);

		if (NameOnlyCheckBox->Checked && ListMode==0 && !EmpPtn.IsEmpty()) {
			TRegExOptions opt; opt << roIgnoreCase;
			TMatch mt = TRegEx::Match(lbuf, EmpPtn, opt);
			if (mt.Success) {
				lbuf = mt.Value;
				if (ends_tchs(_T("([:"), lbuf)) delete_end(lbuf);
			}
		}

		lst->Add(lbuf);
	}
}

//---------------------------------------------------------------------------
//ꗗRs[
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::CopyListActionExecute(TObject *Sender)
{
	std::unique_ptr<TStringList> cbuf(new TStringList());
	GetStrList(cbuf.get());
	copy_to_Clipboard(cbuf->Text);
}

//---------------------------------------------------------------------------
//ꗗt@Cɕۑ
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::SaveListActionExecute(TObject *Sender)
{
	UserModule->SaveTxtDlg->Title		  = LoadUsrMsg(USTR_SaveAs, USTR_List);
	UserModule->SaveTxtDlg->InitialDir	  = ExtractFileDir(TxtViewer->FileName);
	UserModule->SaveTxtDlg->EncodingIndex = SaveEncIndex;
	if (UserModule->SaveTxtDlg->Execute()) {
		SaveEncIndex = UserModule->SaveTxtDlg->EncodingIndex;

		std::unique_ptr<TStringList> fbuf(new TStringList());
		GetStrList(fbuf.get());
		if (!saveto_TextFile(UserModule->SaveTxtDlg->FileName, fbuf.get(), SaveEncIndex))
			msgbox_ERR(LoadUsrMsg(USTR_FaildSave, USTR_List));
	}

	FuncListBox->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::ListActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = FuncListBox->Count>0;
}

//---------------------------------------------------------------------------
void __fastcall TFuncListDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift, HelpContext);
}
//---------------------------------------------------------------------------
